<template>
    <div class="omm-no-file-selected">
        <v-card elevation="2" class="omm-no-file-selected-card">
            <div class="omn-no-file-selected-content">
                <h1 class="omm-no-file-selected__title  mb-4">No file selected</h1>
                <div class="omm-no-file-selected__actions">
                    <p class="d-flex align-center text--secondary">
                        Create new note
                        <span v-if="newNoteShortcut" class="ml-4">({{ newNoteShortcut }})</span>

                        <v-btn fab dark x-small color="secondary" class="ml-4" @click="handleAddNoteClick">
                            <v-icon>mdi-plus</v-icon>
                        </v-btn>
                    </p>

                    <p class="d-flex align-center text--secondary">
                        Create new folder
                        <span v-if="newDirShortcut" class="ml-4">({{ newDirShortcut }})</span>

                        <v-btn fab dark x-small color="secondary" class="ml-4" @click="handleAddFolderClick">
                            <v-icon>mdi-folder-plus</v-icon>
                        </v-btn>
                    </p>
                </div>
            </div>
        </v-card>
    </div>
</template>

<script lang="ts">
import { defineComponent, onMounted, Ref, ref, watch } from '@vue/composition-api';
import { createNewDir, createNewFile } from "@/utils";
import { useShortcuts } from "@/compositions";

export default defineComponent({
    name: "EmptySelection",
    setup () {
        const newNoteShortcut: Ref<string> = ref('');
        const newDirShortcut: Ref<string> = ref('');

        const handleAddFolderClick = () => {
            createNewDir('/');
        }

        const handleAddNoteClick = () => {
            createNewFile('/');
        }

        const setKeyMappings = () => {
            newNoteShortcut.value = useShortcuts().getMappingString('NEW_NOTE');
            newDirShortcut.value = useShortcuts().getMappingString('NEW_DIR');
        }

        const watchKeyMappings = () => {
            const unwatchKeyMappings = watch(useShortcuts().getMappings, () => {

                setKeyMappings();

                unwatchKeyMappings();
            });
        }

        onMounted(() => {
            if (useShortcuts().getMappings.value) {
                setKeyMappings();
            } else {
                watchKeyMappings();
            }
        });

        return { handleAddFolderClick, handleAddNoteClick, newDirShortcut, newNoteShortcut }
    }
});
</script>

<style lang="scss" scoped>
.omm-no-file-selected {
    display: flex;
    align-items: center;
    justify-content: center;
    width: 100%;
    flex-direction: column;
    padding-bottom: 300px;
    padding-top: 40px;

    .omm-no-file-selected-card {
        width: 50%;
        min-width: 300px;
        padding: 2rem;
        .omn-no-file-selected-content {
            width: 100%;
            text-align: left;
        }
    }

}
</style>
